<template>
    <div>
        <el-form :model="formData" :rules="rules" ref="form" label-width="80px" label-position="right" size="small" style="max-width: 500px;">
            <el-form-item prop="typeFlag" label="类别类型">
                <template>
                    <el-select v-model="formData.typeFlag" clearable placeholder="请选择" :disabled="'typeFlag'==subColumn">
                        <el-option v-for="item in typeFlagOptions" :key="item.value" :label="item.label" :value="item.value">
                        </el-option>
                    </el-select>
                </template>
            </el-form-item>
            <el-form-item prop="typeName" label="类别名称">
                <el-input v-model="formData.typeName" :disabled="'typeName'==subColumn"></el-input>
            </el-form-item>
            <el-form-item prop="areaName" label="区域命名" v-if="formData.typeFlag=='1'">
                <el-input v-model="formData.areaName" :disabled="'areaName'==subColumn"></el-input>
            </el-form-item>
            <el-form-item prop="thingName" label="事物命名" v-if="formData.typeFlag=='1'">
                <el-input v-model="formData.thingName" :disabled="'thingName'==subColumn"></el-input>
            </el-form-item>
            <el-form-item prop="icon" label="icon">
                <single-upload v-model="formData.icon" :disabled="'icon'==subColumn"></single-upload>
            </el-form-item>
            <el-form-item prop="icon" label="icon">
                <el-input v-model="formData.icon" :disabled="'icon'==subColumn"></el-input>
            </el-form-item>
            <el-form-item prop="remark" label="备注">
                <el-input v-model="formData.remark" :disabled="'remark'==subColumn"></el-input>
            </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="$store.state.fetchingData" type="primary">保存</el-button>
                <el-button @click="onDelete" v-if="formData.id" type="danger">删除</el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
import formValidator from '../formValidator'

export default {
    created() {
        if (this.$route.query.column) {
            this.subColumn = this.$route.query.column.split(',')[1];
            this.subValue = this.$route.query.column.split(',')[0];
        }

        if (this.$route.query.id) {
            this.$http.get({
                url: '/landmarkType/getOne',
                data: {
                    id: this.$route.query.id
                }
            }).then(res => {
                if (res.success) {


                    this.formData = res.data;

                    if (this.$route.query.column) {
                        this.formData[this.subColumn] = this.subValue;
                    }
                }
            })
        } else {
            if (this.$route.query.column) {
                this.formData[this.subColumn] = this.subValue;
            }
        }

    },
    data() {
        return {
            saving: false,
            formData: {
                typeFlag: '1',
            },
            rules: {
                typeFlag:
                    [
                        { required: true, message: '请输入 类别类型', trigger: 'blur' },
                    ],
                typeName:
                    [
                        { required: true, message: '请输入 类别名称', trigger: 'blur' },
                    ],
            },
            typeFlagOptions: [{
                value: '1',
                label: '地标类别'
            }, {
                value: '2',
                label: '区域类别'
            }, {
                value: '3',
                label: '事物类别'
            }],
            subColumn: '',
            subValue: '',
        }
    },
    methods: {
        onSave() {
            this.$refs.form.validate((valid) => {
                if (valid) {
                    this.submit();
                } else {
                    return false;
                }
            });
        },
        submit() {
            var data = JSON.parse(JSON.stringify(this.formData));
            this.$http.post({
                url: this.formData.id ? '/landmarkType/update' : '/landmarkType/save',
                data: data
            }).then(res => {
                if (res.success) {
                    this.$message.success('成功');
                    this.$router.go(-1);
                } else {
                    this.$message.warning('失败')
                }
            });
        },
        onDelete() {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' }).then(() => {
                return this.$http.post({
                    url: '/landmarkType/del',
                    data: { id: this.formData.id }
                })
            }).then(() => {
                this.$message.success('删除成功');
                this.$router.go(-1);
            }).catch(action => {
                if (action === 'cancel') {
                    this.$message.info('删除取消');
                } else {
                    this.$message.error('删除失败');
                }
            })
        },
    }
}
</script>
<style lang="less" scoped>
</style>
